## cf-python 1.3.2+dfsg1

=== cf/um/umread/c-lib/Makefile ===
HEADERS=umfile.h umfileint.h bits/*.h

LIBRARY=umfile.so

CC=gcc
CFLAGS=-Wall -fPIC -g
CPP=gcc -E -P
LD=ld
LDFLAGS=-shared --build-id
OBJS = umfile.o error.o filetype.o \
	malloc.o linklist.o new_structs.o swap.o

TYPE_DEP_LIBRARY = umfile_typedep.a
TYPE_DEP_DIR = type-dep
TYPE_DEP_LIBRARY_PATH = $(TYPE_DEP_DIR)/$(TYPE_DEP_LIBRARY)

export CC CFLAGS CPP TYPE_DEP_LIBRARY

.PHONY: clean all type-dep

all: $(LIBRARY)

clean:
	rm -f $(OBJS)
	$(MAKE) -C $(TYPE_DEP_DIR) clean

type-dep:
	$(MAKE) -C $(TYPE_DEP_DIR)

$(LIBRARY): $(OBJS) type-dep
	$(LD) $(LDFLAGS) -o $@ $(OBJS) --whole-archive $(TYPE_DEP_LIBRARY_PATH)

%.o: %.c $(HEADERS)
	$(CC) $(CFLAGS) -c $<

#bits/protos_sgl.h: bits/type_dep_protos.h
#	$(CPP) -DBUILD_HDR -DSINGLE $< > $@
#
#bits/protos_dbl.h: bits/type_dep_protos.h
#	$(CPP) -DBUILD_HDR -DDOUBLE $< > $@

=== cf/um/umread/c-lib/type-dep/Makefile ===
STEMS = umfile_test_typedep interpret_header read process_vars \
	debug_dump date_and_time compare levels axes unwgdos

CFLAGS += -I..

SGL_OBJS=$(foreach stem, $(STEMS), $(stem)_sgl.o)
DBL_OBJS=$(foreach stem, $(STEMS), $(stem)_dbl.o)

SGL_TMP_OBJS=$(foreach stem, $(STEMS), $(stem)_sgl_tmp.o)
DBL_TMP_OBJS=$(foreach stem, $(STEMS), $(stem)_dbl_tmp.o)

TMP_OBJS = $(SGL_TMP_OBJS) $(DBL_TMP_OBJS)
OBJS = $(SGL_OBJS) $(DBL_OBJS)

REDEFINES_DBL = redefs_sgl
REDEFINES_SGL = redefs_dbl

LIB = $(TYPE_DEP_LIBRARY)

.PHONY: all clean

all: $(LIB)

clean:
	rm -f $(OBJS) $(TMP_OBJS) $(LIB) $(REDEFINES_SGL) $(REDEFINES_DBL)

%_dbl_tmp.o: %.c $(HEADERS)
	$(CC) $(CFLAGS) -c -DDOUBLE -o $@ $<

%_sgl_tmp.o: %.c $(HEADERS)
	$(CC) $(CFLAGS) -c -DSINGLE -o $@ $<

%_sgl.o: %_sgl_tmp.o $(REDEFINES_SGL)
	objcopy --redefine-syms=$(REDEFINES_SGL) $< $@

%_dbl.o: %_dbl_tmp.o $(REDEFINES_DBL)
	objcopy --redefine-syms=$(REDEFINES_DBL) $< $@

$(REDEFINES_SGL): $(SGL_TMP_OBJS)
	nm -A $(SGL_TMP_OBJS) | awk '/ T /{print $$3, $$3"_sgl"}' | grep -v thunk > $@

$(REDEFINES_DBL): $(DBL_TMP_OBJS)
	nm -A $(DBL_TMP_OBJS) | awk '/ T /{print $$3, $$3"_dbl"}' | grep -v thunk > $@

$(LIB): $(OBJS)
	rm -f $@
	ar r $@ $(OBJS)

=== debian/changelog ===
cf-python (1.3.2+dfsg1-4) unstable; urgency=medium

  * Adapt to netCDF4-python 1.2.5 (Closes: #846730)

 -- Klaus Zimmermann <kz38@zaphodb>  Fri, 09 Dec 2016 17:44:07 +0100

cf-python (1.3.2+dfsg1-3) unstable; urgency=medium

  * Fix FTBFS. Thanks to Gianfranco Costamagna.

 -- Klaus Zimmermann <klaus_zimmermann@gmx.de>  Fri, 21 Oct 2016 17:09:04 +0200

cf-python (1.3.2+dfsg1-2) unstable; urgency=medium

  * Fix sphinxdoc dependency (Closes: #841374)
  * Make build reproducible (Closes: #841497)

 -- Klaus Zimmermann <klaus_zimmermann@gmx.de>  Fri, 21 Oct 2016 13:00:29 +0200

cf-python (1.3.2+dfsg1-1) unstable; urgency=medium

  * Initial release (Closes: #777315)

 -- Klaus Zimmermann <klaus_zimmermann@gmx.de>  Fri, 23 Sep 2016 12:44:59 +0200

=== debian/control ===
Source: cf-python
Section: python
Priority: optional
Maintainer: Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>
Uploaders:
 Klaus Zimmermann <klaus_zimmermann@gmx.de>,
Build-Depends:
 debhelper (>=9),
 dh-python,
 libudunits2-0,
 python-all (>= 2.6.6-3~),
 python-matplotlib,
 python-netcdf4,
 python-numpy,
 python-psutil,
 python-setuptools,
 sphinx-common,
Build-Depends-Indep:
 python-doc,
 python-matplotlib-doc,
 python-numpy-doc,
 python-scipy-doc,
 python-sphinx,
 sphinx-doc,
Standards-Version: 3.9.8
Homepage: http://cfpython.bitbucket.org/
Vcs-Git: https://anonscm.debian.org/git/python-modules/packages/cf-python.git
Vcs-Browser: https://anonscm.debian.org/cgit/python-modules/packages/cf-python.git

Package: python-cf
Architecture: any
Depends:
 libudunits2-0,
 ${misc:Depends},
 ${python:Depends},
 ${shlibs:Depends},
Suggests:
 python-cf-doc,
Description: Python processing of Climate and Forecast (CF) data models (Python 2)
 CF is a netCDF convention which is in wide and growing use for the storage of
 model-generated and observational data relating to the atmosphere, ocean and
 Earth system.
 .
 This package is an implementation of the CF data model, and as such it is an
 API allows for the full scope of data and metadata interactions described by
 the CF conventions.
 .
 With this package you can:
  - Read CF-netCDF files, CFA-netCDF files and UK Met Office fields files and
    PP files.
  - Create CF fields.
  - Write fields to CF-netCDF and CFA-netCDF files on disk.
  - Aggregate collections of fields into as few multidimensional fields as
    possible using the CF aggregation rules.
  - Create, delete and modify a field’s data and metadata.
  - Select and subspace fields according to their metadata.
  - Perform broadcastable, metadata-aware arithmetic, comparison and
    trigonometric operation with fields.
  - Collapse fields by statistical operations.
  - Sensibly deal with date-time data.
  - Allow for cyclic axes.
  - Visualize fields the cfplot package.
 .
 All of the above use Large Amounts of Massive Arrays (LAMA) functionality,
 which allows multiple fields larger than the available memory to exist and be
 manipulated.
 .
 This package installs the library for Python 2.

Package: python-cf-doc
Architecture: all
Section: doc
Depends:
 libjs-jquery,
 libjs-mathjax,
 libjs-requirejs,
 libjs-underscore,
 ${misc:Depends},
 ${sphinxdoc:Depends},
Description: Python processing of Climate and Forecast (CF) data models (Documentation)
 CF is a netCDF convention which is in wide and growing use for the storage of
 model-generated and observational data relating to the atmosphere, ocean and
 Earth system.
 .
 This package is an implementation of the CF data model, and as such it is an
 API allows for the full scope of data and metadata interactions described by
 the CF conventions.
 .
 With this package you can:
  - Read CF-netCDF files, CFA-netCDF files and UK Met Office fields files and
    PP files.
  - Create CF fields.
  - Write fields to CF-netCDF and CFA-netCDF files on disk.
  - Aggregate collections of fields into as few multidimensional fields as
    possible using the CF aggregation rules.
  - Create, delete and modify a field’s data and metadata.
  - Select and subspace fields according to their metadata.
  - Perform broadcastable, metadata-aware arithmetic, comparison and
    trigonometric operation with fields.
  - Collapse fields by statistical operations.
  - Sensibly deal with date-time data.
  - Allow for cyclic axes.
  - Visualize fields the cfplot package.
 .
 All of the above use Large Amounts of Massive Arrays (LAMA) functionality,
 which allows multiple fields larger than the available memory to exist and be
 manipulated.
 .
 This is the common documentation package.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export PYBUILD_NAME=cf

%:
	dh $@  --with python2,sphinxdoc --buildsystem=pybuild

override_dh_auto_build-indep:
	PYTHONPATH=. http_proxy='127.0.0.1:9' sphinx-build -E -b html docs/source docs/build/html

override_dh_auto_test-indep:
	# -indep only builds documentations, so tests would fail and are not necessary

override_dh_auto_test-arch:
	dh_auto_test -a -O--buildsystem=pybuild -- --system=custom \
                     --before-test 'cp -R {dir}/test {build_dir}; echo {build_dir}/test >> {home_dir}/build_dirs_to_rm_before_install' \
                     --test-args='cd {build_dir}; {interpreter} test/run_tests.py'
	# Delete (unreproducible) file generated in tests so it does not appear
	# in the .deb.
	find -type f -name delme.nca -delete

override_dh_installdocs-indep:
	dh_installdocs -i
	ln -s /usr/share/javascript/mathjax/MathJax.js $(CURDIR)/docs/build/html/_static/
	ln -s /usr/share/javascript/jquery/jquery.min.js $(CURDIR)/docs/build/html/_static/
	ln -s /usr/share/javascript/requirejs/requirejs.min.js $(CURDIR)/docs/build/html/_static/
	find docs/build/html -name "*.html" -exec sed -i "s|https://cdn.mathjax.org/mathjax/latest/MathJax.js|_static/MathJax.js|" {} \;
	find docs/build/html -name "*.html" -exec sed -i "s|https://cdnjs.cloudflare.com/ajax/libs/jquery/2.0.3/jquery.min.js|_static/jquery.min.js|" {} \;
	find docs/build/html -name "*.html" -exec sed -i "s|https://cdnjs.cloudflare.com/ajax/libs/require.js/2.1.10/require.min.js|_static/require.min.js|" {} \;
	dh_installdocs -ppython-cf-doc docs/build/html

=== debian/watch ===
version=3
opts="dversionmangle=s/\+dfsg\d+$//,\
uversionmangle=s/(rc|a|b|c)/~$1/,\
repacksuffix=+dfsg1" \
https://pypi.debian.net/cf-python/cf-python-(.+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
